>From 02917018f410647d62ea5502bd653390fae16998 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Sun, 26 Oct 2014 00:29:36 -0400
Subject: [PATCH 237/238] Added Python Client API Docs to build

This patch builds HTML and man page builds for the python
client API delivered in pki-base.

Ticket 1157
---
 base/common/CMakeLists.txt             |   1 +
 base/common/python/docs/CMakeLists.txt |  47 ++++++
 base/common/python/docs/conf.py.in     | 285 +++++++++++++++++++++++++++++++++
 base/common/python/docs/index.rst      |  22 +++
 base/common/python/docs/pki.rst        | 107 +++++++++++++
 cmake/Modules/FindSphinx.cmake         |  13 ++
 specs/pki-core.spec                    |   8 +-
 7 files changed, 480 insertions(+), 3 deletions(-)
 create mode 100644 base/common/python/docs/CMakeLists.txt
 create mode 100644 base/common/python/docs/conf.py.in
 create mode 100644 base/common/python/docs/index.rst
 create mode 100644 base/common/python/docs/pki.rst
 create mode 100644 cmake/Modules/FindSphinx.cmake

diff --git a/base/common/CMakeLists.txt b/base/common/CMakeLists.txt
index f661890f2a4faf6c4c7f504670523582cdaabe6d..f82a0df8918064b8cbf3bb0842b0347b3e931f6f 100644
--- a/base/common/CMakeLists.txt
+++ b/base/common/CMakeLists.txt
@@ -99,3 +99,4 @@ install(
 )
 
 add_subdirectory(src)
+add_subdirectory(python/docs)
diff --git a/base/common/python/docs/CMakeLists.txt b/base/common/python/docs/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..51e8c287acdb91e548e1b2fa702b48f1e3a93054
--- /dev/null
+++ b/base/common/python/docs/CMakeLists.txt
@@ -0,0 +1,47 @@
+find_package(Sphinx REQUIRED)
+
+if(NOT DEFINED SPHINX_THEME)
+    set(SPHINX_THEME default)
+endif()
+
+if(NOT DEFINED SPHINX_THEME_DIR)
+    set(SPHINX_THEME_DIR)
+endif()
+
+# configured documentation tools and intermediate build results
+set(BINARY_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/_build")
+
+# Sphinx cache with pickled ReST documents
+set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/_doctrees")
+
+# HTML output directory
+set(SPHINX_HTML_DIR "${CMAKE_CURRENT_BINARY_DIR}/../../../../../base/common/html")
+
+# MAN output directory
+set(SPHINX_MAN_DIR "${CMAKE_CURRENT_BINARY_DIR}/../../../../../base/common/man/man1")
+
+configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in"
+    "${BINARY_BUILD_DIR}/conf.py"
+    @ONLY)
+
+add_custom_target(dogtag_python_client_docs ALL
+    ${SPHINX_EXECUTABLE}
+        -b html
+        -c "${BINARY_BUILD_DIR}"
+        -d "${SPHINX_CACHE_DIR}"
+        -a
+        "${CMAKE_CURRENT_SOURCE_DIR}"
+        "${SPHINX_HTML_DIR}"
+    COMMENT "Building HTML documentation with Sphinx")
+
+add_custom_target(dogtag_python_client_man_docs ALL
+    ${SPHINX_EXECUTABLE}
+        -b man
+        -c "${BINARY_BUILD_DIR}"
+        -d "${SPHINX_CACHE_DIR}"
+        -a
+        "${CMAKE_CURRENT_SOURCE_DIR}"
+        "${SPHINX_MAN_DIR}"
+    COMMENT "Building man page documentation with Sphinx")
+
diff --git a/base/common/python/docs/conf.py.in b/base/common/python/docs/conf.py.in
new file mode 100644
index 0000000000000000000000000000000000000000..eca3b1a0b090bb9b6f51a6e1a3bc4df05b74b040
--- /dev/null
+++ b/base/common/python/docs/conf.py.in
@@ -0,0 +1,285 @@
+# -*- coding: utf-8 -*-
+#
+# python documentation build configuration file, created by
+# sphinx-quickstart on Fri Oct 24 13:58:43 2014.
+#
+# This file is execfile()d with the current directory set to its containing dir.
+#
+# Note that not all possible configuration values are present in this
+# autogenerated file.
+#
+# All configuration values have a default; values that are commented out
+# serve to show the default.
+
+import sys, os
+
+# If extensions (or modules to document with autodoc) are in another directory,
+# add these directories to sys.path here. If the directory is relative to the
+# documentation root, use os.path.abspath to make it absolute, like shown here.
+sys.path.insert(0, os.path.abspath('../pki'))
+
+# -- General configuration -----------------------------------------------------
+
+# If your documentation needs a minimal Sphinx version, state it here.
+#needs_sphinx = '1.0'
+
+# Add any Sphinx extension module names here, as strings. They can be extensions
+# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
+extensions = ['sphinx.ext.autodoc', 'sphinx.ext.viewcode']
+
+# Add any paths that contain templates here, relative to this directory.
+templates_path = ['_templates']
+
+# The suffix of source filenames.
+source_suffix = '.rst'
+
+# The encoding of source files.
+#source_encoding = 'utf-8-sig'
+
+# The master toctree document.
+master_doc = 'index'
+
+# General information about the project.
+project = u'Dogtag Certificate System'
+copyright = u'2014, Dogtag PKI Team'
+
+# The version info for the project you're documenting, acts as replacement for
+# |version| and |release|, also used in various other places throughout the
+# built documents.
+#
+# The short X.Y version.
+version = '@APPLICATION_VERSION@'
+# The full version, including alpha/beta/rc tags.
+release = '@APPLICATION_VERSION@'
+
+# The language for content autogenerated by Sphinx. Refer to documentation
+# for a list of supported languages.
+#language = None
+
+# There are two options for replacing |today|: either, you set today to some
+# non-false value, then it is used:
+#today = ''
+# Else, today_fmt is used as the format for a strftime call.
+#today_fmt = '%B %d, %Y'
+
+# List of patterns, relative to source directory, that match files and
+# directories to ignore when looking for source files.
+exclude_patterns = ['_build', 'key', 'docs']
+
+# The reST default role (used for this markup: `text`) to use for all documents.
+#default_role = None
+
+# If true, '()' will be appended to :func: etc. cross-reference text.
+#add_function_parentheses = True
+
+# If true, the current module name will be prepended to all description
+# unit titles (such as .. function::).
+#add_module_names = True
+
+# If true, sectionauthor and moduleauthor directives will be shown in the
+# output. They are ignored by default.
+#show_authors = False
+
+# The name of the Pygments (syntax highlighting) style to use.
+pygments_style = 'sphinx'
+
+# A list of ignored prefixes for module index sorting.
+#modindex_common_prefix = []
+
+
+# -- Options for HTML output ---------------------------------------------------
+
+# The theme to use for HTML and HTML Help pages.  See the documentation for
+# a list of builtin themes.
+html_theme = 'default'
+
+# Theme options are theme-specific and customize the look and feel of a theme
+# further.  For a list of options available for each theme, see the
+# documentation.
+#html_theme_options = {}
+
+# Add any paths that contain custom themes here, relative to this directory.
+#html_theme_path = []
+
+# The name for this set of Sphinx documents.  If None, it defaults to
+# "<project> v<release> documentation".
+#html_title = None
+
+# A shorter title for the navigation bar.  Default is the same as html_title.
+#html_short_title = None
+
+# The name of an image file (relative to this directory) to place at the top
+# of the sidebar.
+#html_logo = None
+
+# The name of an image file (within the static path) to use as favicon of the
+# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
+# pixels large.
+#html_favicon = None
+
+# Add any paths that contain custom static files (such as style sheets) here,
+# relative to this directory. They are copied after the builtin static files,
+# so a file named "default.css" will overwrite the builtin "default.css".
+html_static_path = ['_static']
+
+# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
+# using the given strftime format.
+#html_last_updated_fmt = '%b %d, %Y'
+
+# If true, SmartyPants will be used to convert quotes and dashes to
+# typographically correct entities.
+#html_use_smartypants = True
+
+# Custom sidebar templates, maps document names to template names.
+#html_sidebars = {}
+
+# Additional templates that should be rendered to pages, maps page names to
+# template names.
+#html_additional_pages = {}
+
+# If false, no module index is generated.
+#html_domain_indices = True
+
+# If false, no index is generated.
+#html_use_index = True
+
+# If true, the index is split into individual pages for each letter.
+#html_split_index = False
+
+# If true, links to the reST sources are added to the pages.
+#html_show_sourcelink = True
+
+# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
+#html_show_sphinx = True
+
+# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
+#html_show_copyright = True
+
+# If true, an OpenSearch description file will be output, and all pages will
+# contain a <link> tag referring to it.  The value of this option must be the
+# base URL from which the finished HTML is served.
+#html_use_opensearch = ''
+
+# This is the file name suffix for HTML files (e.g. ".xhtml").
+#html_file_suffix = None
+
+# Output file base name for HTML help builder.
+htmlhelp_basename = 'pythondoc'
+
+
+# -- Options for LaTeX output --------------------------------------------------
+
+latex_elements = {
+# The paper size ('letterpaper' or 'a4paper').
+#'papersize': 'letterpaper',
+
+# The font size ('10pt', '11pt' or '12pt').
+#'pointsize': '10pt',
+
+# Additional stuff for the LaTeX preamble.
+#'preamble': '',
+}
+
+# Grouping the document tree into LaTeX files. List of tuples
+# (source start file, target name, title, author, documentclass [howto/manual]).
+latex_documents = [
+  ('index', 'dogtag.tex', u'Dogtag Certificate Server Python Client Documentation',
+   u'Author', 'manual'),
+]
+
+# The name of an image file (relative to this directory) to place at the top of
+# the title page.
+#latex_logo = None
+
+# For "manual" documents, if this is true, then toplevel headings are parts,
+# not chapters.
+#latex_use_parts = False
+
+# If true, show page references after internal links.
+#latex_show_pagerefs = False
+
+# If true, show URL addresses after external links.
+#latex_show_urls = False
+
+# Documents to append as an appendix to all manuals.
+#latex_appendices = []
+
+# If false, no module index is generated.
+#latex_domain_indices = True
+
+
+# -- Options for manual page output --------------------------------------------
+
+# One entry per manual page. List of tuples
+# (source start file, name, description, authors, manual section).
+man_pages = [
+    ('index', 'pki-python-client', u'Dogtag Python Client Documentation',
+     [u'Dogtag PKI Project Team'], 1)
+]
+
+# If true, show URL addresses after external links.
+#man_show_urls = False
+
+
+# -- Options for Texinfo output ------------------------------------------------
+
+# Grouping the document tree into Texinfo files. List of tuples
+# (source start file, target name, title, author,
+#  dir menu entry, description, category)
+texinfo_documents = [
+  ('index', 'Dogtag', u'Dogtag Certificate Server Python Client Documentation',
+   u'Author', 'Dogtag PKI Team', 'Dogtag is an enterprise software system designed to manage enterprise Public Key Infrastructure (PKI) deployments.',
+   'Miscellaneous'),
+]
+
+# Documents to append as an appendix to all manuals.
+#texinfo_appendices = []
+
+# If false, no module index is generated.
+#texinfo_domain_indices = True
+
+# How to display URL addresses: 'footnote', 'no', or 'inline'.
+#texinfo_show_urls = 'footnote'
+
+
+# -- Options for Epub output ---------------------------------------------------
+
+# Bibliographic Dublin Core info.
+epub_title = u'Dogtag Certificate Server'
+epub_author = u'Dogtag PKI Team'
+epub_publisher = u'Dogtag PKI Team'
+epub_copyright = u'2014, Dogtag PKI Team'
+
+# The language of the text. It defaults to the language option
+# or en if the language is not set.
+#epub_language = ''
+
+# The scheme of the identifier. Typical schemes are ISBN or URL.
+#epub_scheme = ''
+
+# The unique identifier of the text. This can be a ISBN number
+# or the project homepage.
+#epub_identifier = ''
+
+# A unique identification for the text.
+#epub_uid = ''
+
+# A tuple containing the cover image and cover page html template filenames.
+#epub_cover = ()
+
+# HTML files that should be inserted before the pages created by sphinx.
+# The format is a list of tuples containing the path and title.
+#epub_pre_files = []
+
+# HTML files shat should be inserted after the pages created by sphinx.
+# The format is a list of tuples containing the path and title.
+#epub_post_files = []
+
+# A list of files that should not be packed into the epub file.
+#epub_exclude_files = []
+
+# The depth of the table of contents in toc.ncx.
+#epub_tocdepth = 3
+
+# Allow duplicate toc entries.
+#epub_tocdup = True
diff --git a/base/common/python/docs/index.rst b/base/common/python/docs/index.rst
new file mode 100644
index 0000000000000000000000000000000000000000..8422a78bd58a380087b16cb43bcf852cdbc83b02
--- /dev/null
+++ b/base/common/python/docs/index.rst
@@ -0,0 +1,22 @@
+Welcome to Dogtag's Python Client documentation!
+================================================
+
+Dogtag is an enterprise software system designed to manage
+enterprise Public Key Infrastructure (PKI) deployments.
+These pages document the Python client API that can be used
+to interact with Dogtag's REST API to request and issue certificates,
+store secrets in the KRA etc.
+
+.. toctree::
+   :maxdepth: 4
+
+   pki
+
+
+Indices and tables
+==================
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`
+
diff --git a/base/common/python/docs/pki.rst b/base/common/python/docs/pki.rst
new file mode 100644
index 0000000000000000000000000000000000000000..f19a63ee7bbbacda518d760ed9d100fef2e044ec
--- /dev/null
+++ b/base/common/python/docs/pki.rst
@@ -0,0 +1,107 @@
+pki Package
+===========
+
+:mod:`pki` Package
+------------------
+
+.. automodule:: pki
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`account` Module
+---------------------
+
+.. automodule:: pki.account
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`cert` Module
+------------------
+
+.. automodule:: pki.cert
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`client` Module
+--------------------
+
+.. automodule:: pki.client
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`crypto` Module
+--------------------
+
+.. automodule:: pki.crypto
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`encoder` Module
+---------------------
+
+.. automodule:: pki.encoder
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`key` Module
+-----------------
+
+.. automodule:: pki.key
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`kra` Module
+-----------------
+
+.. automodule:: pki.kra
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`profile` Module
+---------------------
+
+.. automodule:: pki.profile
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`system` Module
+--------------------
+
+.. automodule:: pki.system
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`systemcert` Module
+------------------------
+
+.. automodule:: pki.systemcert
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`upgrade` Module
+---------------------
+
+.. automodule:: pki.upgrade
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`util` Module
+------------------
+
+.. automodule:: pki.util
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
diff --git a/cmake/Modules/FindSphinx.cmake b/cmake/Modules/FindSphinx.cmake
new file mode 100644
index 0000000000000000000000000000000000000000..ec03cdefafbba7670dbcb41a70cca9c94dbbdae5
--- /dev/null
+++ b/cmake/Modules/FindSphinx.cmake
@@ -0,0 +1,13 @@
+find_program(SPHINX_EXECUTABLE
+    NAMES sphinx-build
+    PATHS /bin
+    DOC "Sphinx documentation generator"
+)
+
+include(FindPackageHandleStandardArgs)
+
+find_package_handle_standard_args(Sphinx DEFAULT_MSG
+    SPHINX_EXECUTABLE
+)
+
+mark_as_advanced(SPHINX_EXECUTABLE)
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 5e80ae48fea273df1ae5026d7c62e643bfdcd195..197cc1e11e174a41bc0b8570820e9d43de16011e 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -33,6 +33,7 @@ BuildRequires:    nss-devel >= 3.14.3
 BuildRequires:    openldap-devel
 BuildRequires:    pkgconfig
 BuildRequires:    policycoreutils
+BuildRequires:    python-sphinx
 BuildRequires:    velocity
 BuildRequires:    xalan-j2
 BuildRequires:    xerces-j2
@@ -688,6 +689,7 @@ echo >> /var/log/pki/pki-server-upgrade-%{version}.log 2>&1
 %files -n pki-base
 %defattr(-,root,root,-)
 %doc base/common/LICENSE
+%doc base/common/html/
 %dir %{_datadir}/pki
 %{_datadir}/pki/VERSION
 %{_datadir}/pki/etc/
@@ -706,6 +708,7 @@ echo >> /var/log/pki/pki-server-upgrade-%{version}.log 2>&1
 %dir %{_localstatedir}/log/pki
 %{_sbindir}/pki-upgrade
 %{_mandir}/man8/pki-upgrade.8.gz
+%{_mandir}/man1/pki-python-client.1.gz
 
 %files -n pki-tools
 %defattr(-,root,root,-)
@@ -855,15 +858,14 @@ echo >> /var/log/pki/pki-server-upgrade-%{version}.log 2>&1
 - Updated version number to 10.2.1-0.1.
 - Added CLIs to simplify generating user certificates
 - Added enhancements to KRA Python API
-
-* Wed Oct 15 2014 Abhishek Koneru <akoneru@redhat.com>
-- Added a man page for pki ca-profile commands.
+- Added python api docs
 
 * Wed Oct 1 2014 Ade Lee <alee@redhat.com> 10.2.0-3
 - Disable pylint dependency for RHEL builds
 - Added jakarta-commons-httpclient requirements
 - Added tomcat version for RHEL build
 - Added resteasy-base-client for RHEL build
+- Added a man page for pki ca-profile commands. (akoneru)
 
 * Wed Sep 24 2014 Matthew Harmsen <mharmsen@redhat.com> - 10.2.0-2
 - PKI TRAC Ticket #1130 - Add RHEL/CentOS conditionals to spec
-- 
1.9.3