From 5bf3a94a9c3374e34bf66fe5b1725ff9b49a1f3c Mon Sep 17 00:00:00 2001
From: Christian Heimes <cheimes@redhat.com>
Date: Tue, 19 Jan 2016 14:37:52 +0100
Subject: [PATCH] Remove #!python shebang from non-executables

A lot of Python files start with a #!/usr/bin/python shebang although
the files are neither executables nor designed as scripts. Shebangs are
only required for executable scripts.

Without unnecessary shebangs it's a bit easier to track Python 3
porting.
---
 base/common/python/pki/__init__.py                                      | 1 -
 base/common/python/pki/account.py                                       | 1 -
 base/common/python/pki/authority.py                                     | 2 --
 base/common/python/pki/cert.py                                          | 2 --
 base/common/python/pki/cli.py                                           | 1 -
 base/common/python/pki/client.py                                        | 1 -
 base/common/python/pki/crypto.py                                        | 1 -
 base/common/python/pki/feature.py                                       | 2 --
 base/common/python/pki/key.py                                           | 2 --
 base/common/python/pki/kra.py                                           | 1 -
 base/common/python/pki/nss.py                                           | 1 -
 base/common/python/pki/profile.py                                       | 1 -
 base/common/python/pki/system.py                                        | 1 -
 base/common/python/pki/systemcert.py                                    | 1 -
 base/common/python/pki/upgrade.py                                       | 1 -
 base/common/python/pki/util.py                                          | 1 -
 base/server/python/pki/server/__init__.py                               | 1 -
 base/server/python/pki/server/ca.py                                     | 1 -
 base/server/python/pki/server/cli/ca.py                                 | 1 -
 base/server/python/pki/server/cli/instance.py                           | 1 -
 base/server/python/pki/server/cli/migrate.py                            | 1 -
 base/server/python/pki/server/cli/nuxwdog.py                            | 1 -
 base/server/python/pki/server/cli/subsystem.py                          | 1 -
 base/server/python/pki/server/deployment/pkiconfig.py                   | 1 -
 base/server/python/pki/server/deployment/pkihelper.py                   | 2 --
 base/server/python/pki/server/deployment/pkilogging.py                  | 1 -
 base/server/python/pki/server/deployment/pkimanifest.py                 | 1 -
 base/server/python/pki/server/deployment/pkimessages.py                 | 1 -
 base/server/python/pki/server/deployment/pkiparser.py                   | 1 -
 base/server/python/pki/server/deployment/pkiscriptlet.py                | 1 -
 base/server/python/pki/server/deployment/scriptlets/configuration.py    | 1 -
 base/server/python/pki/server/deployment/scriptlets/finalization.py     | 1 -
 .../python/pki/server/deployment/scriptlets/infrastructure_layout.py    | 1 -
 base/server/python/pki/server/deployment/scriptlets/initialization.py   | 1 -
 base/server/python/pki/server/deployment/scriptlets/instance_layout.py  | 1 -
 .../python/pki/server/deployment/scriptlets/security_databases.py       | 1 -
 base/server/python/pki/server/deployment/scriptlets/selinux_setup.py    | 1 -
 .../server/python/pki/server/deployment/scriptlets/slot_substitution.py | 1 -
 base/server/python/pki/server/deployment/scriptlets/subsystem_layout.py | 1 -
 .../server/python/pki/server/deployment/scriptlets/webapp_deployment.py | 1 -
 base/server/python/pki/server/upgrade.py                                | 1 -
 41 files changed, 46 deletions(-)

diff --git a/base/common/python/pki/__init__.py b/base/common/python/pki/__init__.py
index 652b6697d0c2dca93f7cdbe492ae243889d4a54f..4c4b88ae7af46c21a0014eee00793850779fbd0f 100644
--- a/base/common/python/pki/__init__.py
+++ b/base/common/python/pki/__init__.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/account.py b/base/common/python/pki/account.py
index 9125df875331777733b626cf493bd46b634f40ce..ee7507be7ebf509f564955fa42b77eb84d965a93 100644
--- a/base/common/python/pki/account.py
+++ b/base/common/python/pki/account.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/authority.py b/base/common/python/pki/authority.py
index 5604e9e3a6edd5c6bc1baffb68aad728bdb58139..8827db88aac879f450b47e88754972c242595b8e 100644
--- a/base/common/python/pki/authority.py
+++ b/base/common/python/pki/authority.py
@@ -1,5 +1,3 @@
-#!/usr/bin/python
-
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
diff --git a/base/common/python/pki/cert.py b/base/common/python/pki/cert.py
index 00f6a4168fb91a1018ade917dbb955c535c22184..c03bf60074581eaaf2b16d2f940b5175623c4fd5 100644
--- a/base/common/python/pki/cert.py
+++ b/base/common/python/pki/cert.py
@@ -1,5 +1,3 @@
-#!/usr/bin/python
-
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
diff --git a/base/common/python/pki/cli.py b/base/common/python/pki/cli.py
index 6c51c2384282713f132d96e77722ed3ada4b5aee..3be9cce2e5583e2ee519cdb2860e6346f90426da 100644
--- a/base/common/python/pki/cli.py
+++ b/base/common/python/pki/cli.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/client.py b/base/common/python/pki/client.py
index 581f0b0ad1c42874ec4505eebb214071725f2c53..7617a0b632626b13eed47b235e3d86029769b735 100644
--- a/base/common/python/pki/client.py
+++ b/base/common/python/pki/client.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/crypto.py b/base/common/python/pki/crypto.py
index cf97a668cf96b17f882599498e5d5b5fff69bd35..60e83c924a6986152ba732cc63b668a906350228 100644
--- a/base/common/python/pki/crypto.py
+++ b/base/common/python/pki/crypto.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Ade Lee <alee@redhat.com>
 #
diff --git a/base/common/python/pki/feature.py b/base/common/python/pki/feature.py
index fd9d405516a2a2c2e0a1ed414e1ce3ef9934e557..45af63c07d0f74c5b2a843acf6ab50d243e67758 100644
--- a/base/common/python/pki/feature.py
+++ b/base/common/python/pki/feature.py
@@ -1,5 +1,3 @@
-#!/usr/bin/python
-
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
diff --git a/base/common/python/pki/key.py b/base/common/python/pki/key.py
index 4a6f50bdd7966e53068ee34bf3d44db350e21ba1..74f04bb1e46090e8d2c2874bae125d34efd8ca74 100644
--- a/base/common/python/pki/key.py
+++ b/base/common/python/pki/key.py
@@ -1,5 +1,3 @@
-#!/usr/bin/python
-#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
diff --git a/base/common/python/pki/kra.py b/base/common/python/pki/kra.py
index ca756c3c145ec420afc22e48231641b7e1aecc62..522773ba2a46f4790332094a0b577c8b878c59c5 100644
--- a/base/common/python/pki/kra.py
+++ b/base/common/python/pki/kra.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Abhishek Koneru <akoneru@redhat.com>
 #     Ade Lee <alee@redhat.com>
diff --git a/base/common/python/pki/nss.py b/base/common/python/pki/nss.py
index 67fd90b4cf8046e64b9291296489a5f04e22efcd..44e286853c252675bff9e25c32377aaa86f8cf18 100644
--- a/base/common/python/pki/nss.py
+++ b/base/common/python/pki/nss.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/profile.py b/base/common/python/pki/profile.py
index 7d6bb5ef22fcf28e4d63b75ea0b3466dc2d05c0b..c463a6ba91bd7fcad907ec1231039f38d1bb143d 100644
--- a/base/common/python/pki/profile.py
+++ b/base/common/python/pki/profile.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
diff --git a/base/common/python/pki/system.py b/base/common/python/pki/system.py
index f1128fca1aced5bd9ec0200d02ba15cd69afa14e..45aa0d6372407634715ac24273c8743ad1d29b31 100644
--- a/base/common/python/pki/system.py
+++ b/base/common/python/pki/system.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/systemcert.py b/base/common/python/pki/systemcert.py
index 199838b9eb8547918ecddf12d9043fb7a5def81e..a7d4e1c718cf8368b3f832bbec61ef5e78fae080 100644
--- a/base/common/python/pki/systemcert.py
+++ b/base/common/python/pki/systemcert.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Ade Lee <alee@redhat.com>
 #
diff --git a/base/common/python/pki/upgrade.py b/base/common/python/pki/upgrade.py
index bc7e278e77d72026774da975ad5b1cfee9045b7e..2261ba82288d37dea13edcefb5474c78f01e391d 100644
--- a/base/common/python/pki/upgrade.py
+++ b/base/common/python/pki/upgrade.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/common/python/pki/util.py b/base/common/python/pki/util.py
index 55fa3b31769a13f7c0773335ed298dacb767901b..7220a7d498741e4a2c6b405a75e34ea4eaa8934f 100644
--- a/base/common/python/pki/util.py
+++ b/base/common/python/pki/util.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/__init__.py b/base/server/python/pki/server/__init__.py
index bf592dcd59bf07314b94447d5da7ddbdf0077c8b..98b7d97bfaf237d97bda1246ac9a26fde1c70402 100644
--- a/base/server/python/pki/server/__init__.py
+++ b/base/server/python/pki/server/__init__.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/ca.py b/base/server/python/pki/server/ca.py
index 31e373ad85955fd1e64b08c8f5aedba8386384fa..afb281cc1b6fdb6fb983a105a8d8fba8fa9b429b 100644
--- a/base/server/python/pki/server/ca.py
+++ b/base/server/python/pki/server/ca.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/cli/ca.py b/base/server/python/pki/server/cli/ca.py
index 2ad8652f4fddd032779941cb7e2ae4e643c25e0a..e35e741c55102e03276b81868a4997d1d05f4f7a 100644
--- a/base/server/python/pki/server/cli/ca.py
+++ b/base/server/python/pki/server/cli/ca.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/cli/instance.py b/base/server/python/pki/server/cli/instance.py
index fe50b605da37943dd66b594326bcc4524b03fc67..5e70e5f28c566ed7db7f7b35fa08327661bacdbe 100644
--- a/base/server/python/pki/server/cli/instance.py
+++ b/base/server/python/pki/server/cli/instance.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/cli/migrate.py b/base/server/python/pki/server/cli/migrate.py
index 09427974e9f900e5d52d3fe0e3b4c2a206778a2e..9c5c0c6f4604c15b8e91900de486e0ac90692b97 100644
--- a/base/server/python/pki/server/cli/migrate.py
+++ b/base/server/python/pki/server/cli/migrate.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/cli/nuxwdog.py b/base/server/python/pki/server/cli/nuxwdog.py
index dbdf973b659052779001d019a3de1cfe2aa94cf5..ca9c7c39b0240e4394de210ecc110db116221fec 100644
--- a/base/server/python/pki/server/cli/nuxwdog.py
+++ b/base/server/python/pki/server/cli/nuxwdog.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Ade Lee <alee@redhat.com>
 #
diff --git a/base/server/python/pki/server/cli/subsystem.py b/base/server/python/pki/server/cli/subsystem.py
index 14b5be2f56df7786dafbea418d8bcec7c4cae39e..d033142f5be2a221a30b9b750da80a3143b79574 100644
--- a/base/server/python/pki/server/cli/subsystem.py
+++ b/base/server/python/pki/server/cli/subsystem.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkiconfig.py b/base/server/python/pki/server/deployment/pkiconfig.py
index 1198eea13322372b5bc0cf6cc2ad0a77b958ad14..675926df506bc4e97d21713e25cf5ec3061c8e69 100644
--- a/base/server/python/pki/server/deployment/pkiconfig.py
+++ b/base/server/python/pki/server/deployment/pkiconfig.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkihelper.py b/base/server/python/pki/server/deployment/pkihelper.py
index 7a1a8c7d145628313868b614123977165b9015bf..43a404625b855d27163eab388c59d3a977c8f0ee 100644
--- a/base/server/python/pki/server/deployment/pkihelper.py
+++ b/base/server/python/pki/server/deployment/pkihelper.py
@@ -1,5 +1,3 @@
-#!/usr/bin/python -t
-
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkilogging.py b/base/server/python/pki/server/deployment/pkilogging.py
index 6378ff06299f5ed366eb8bd7f3667758bc4d6466..7a7afd707b9c23d556a4dee33f28268501435a81 100644
--- a/base/server/python/pki/server/deployment/pkilogging.py
+++ b/base/server/python/pki/server/deployment/pkilogging.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkimanifest.py b/base/server/python/pki/server/deployment/pkimanifest.py
index 09c9ac6681d5dbde0be7de5882b2ba0e0d82dc85..1cde3f7d792cdf9e5b0e07f4b6db15ac8827c387 100644
--- a/base/server/python/pki/server/deployment/pkimanifest.py
+++ b/base/server/python/pki/server/deployment/pkimanifest.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkimessages.py b/base/server/python/pki/server/deployment/pkimessages.py
index 64923730711526b7eca15c70c36f844774248fd0..b16051b6c19f1e6d8d88b7419781a11c5dee27f4 100644
--- a/base/server/python/pki/server/deployment/pkimessages.py
+++ b/base/server/python/pki/server/deployment/pkimessages.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkiparser.py b/base/server/python/pki/server/deployment/pkiparser.py
index d2b37d0622b4131a5737f77571adfb3e5fc7b94e..2b447911832a55d597545c2e953f5a42d783595a 100644
--- a/base/server/python/pki/server/deployment/pkiparser.py
+++ b/base/server/python/pki/server/deployment/pkiparser.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/pkiscriptlet.py b/base/server/python/pki/server/deployment/pkiscriptlet.py
index 43fc694887093287f0d812e3220208eb2a4f9a51..356e8ebcaf9ae1f5e5e15404b29a0569e163b1e7 100644
--- a/base/server/python/pki/server/deployment/pkiscriptlet.py
+++ b/base/server/python/pki/server/deployment/pkiscriptlet.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/configuration.py b/base/server/python/pki/server/deployment/scriptlets/configuration.py
index a80239374da7a4184bbf593bb9069673a9d9c8dd..575a347c20285454b80e6394c5168c77bf2af885 100644
--- a/base/server/python/pki/server/deployment/scriptlets/configuration.py
+++ b/base/server/python/pki/server/deployment/scriptlets/configuration.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/finalization.py b/base/server/python/pki/server/deployment/scriptlets/finalization.py
index 3c4f469aced9eec7928cf2c1a27ac43ebe5e1886..c816acd2025fdaff3296bcf978c4df315bea2230 100644
--- a/base/server/python/pki/server/deployment/scriptlets/finalization.py
+++ b/base/server/python/pki/server/deployment/scriptlets/finalization.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/infrastructure_layout.py b/base/server/python/pki/server/deployment/scriptlets/infrastructure_layout.py
index f7ef82825ade768994632c53872d1d8f0a745559..1334cb03c3233a46168980e4844fbc28d936ec2f 100644
--- a/base/server/python/pki/server/deployment/scriptlets/infrastructure_layout.py
+++ b/base/server/python/pki/server/deployment/scriptlets/infrastructure_layout.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/initialization.py b/base/server/python/pki/server/deployment/scriptlets/initialization.py
index dae5a4b14d6cee09f884d22c7d75251b76211fb0..634136caf6426667f8f6b0547e9ef5d874ce4f61 100644
--- a/base/server/python/pki/server/deployment/scriptlets/initialization.py
+++ b/base/server/python/pki/server/deployment/scriptlets/initialization.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 # Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/instance_layout.py b/base/server/python/pki/server/deployment/scriptlets/instance_layout.py
index 4ed50514352ca09aa79e8ce04ee6d824ed93f594..eeca2bc0f9217988f9dcd74179ea1ba7498a4019 100644
--- a/base/server/python/pki/server/deployment/scriptlets/instance_layout.py
+++ b/base/server/python/pki/server/deployment/scriptlets/instance_layout.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 # Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/security_databases.py b/base/server/python/pki/server/deployment/scriptlets/security_databases.py
index 27285dd3eaa61d788a6fb6047911b9bb9fc878a9..94ecbc2f026dbf8f48b281e9ee9def518d24a861 100644
--- a/base/server/python/pki/server/deployment/scriptlets/security_databases.py
+++ b/base/server/python/pki/server/deployment/scriptlets/security_databases.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/selinux_setup.py b/base/server/python/pki/server/deployment/scriptlets/selinux_setup.py
index 97fe5b32c420be228afa0e218af515322cb82230..cff6acf31053e64cfd10f733cb9ba53cf9d17af0 100644
--- a/base/server/python/pki/server/deployment/scriptlets/selinux_setup.py
+++ b/base/server/python/pki/server/deployment/scriptlets/selinux_setup.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Ade Lee <alee@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/slot_substitution.py b/base/server/python/pki/server/deployment/scriptlets/slot_substitution.py
index b35989cc962f1ae0d3abb39ee2a4e29f5be02b1f..bdee48c1f92b336a9b3a7e4337b0d8f4b2a62832 100644
--- a/base/server/python/pki/server/deployment/scriptlets/slot_substitution.py
+++ b/base/server/python/pki/server/deployment/scriptlets/slot_substitution.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/subsystem_layout.py b/base/server/python/pki/server/deployment/scriptlets/subsystem_layout.py
index 598a235c9caefdff3f54fcafda602e1003c44b6c..49899da6838126415657b93a763669575d1ba78e 100644
--- a/base/server/python/pki/server/deployment/scriptlets/subsystem_layout.py
+++ b/base/server/python/pki/server/deployment/scriptlets/subsystem_layout.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/deployment/scriptlets/webapp_deployment.py b/base/server/python/pki/server/deployment/scriptlets/webapp_deployment.py
index 2dafe6f8188b2dd9676a4a4c087b155dd71129d3..f9d0ae9b64165de6a9caabe40981a555520ad4fc 100644
--- a/base/server/python/pki/server/deployment/scriptlets/webapp_deployment.py
+++ b/base/server/python/pki/server/deployment/scriptlets/webapp_deployment.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python -t
 # Authors:
 #     Matthew Harmsen <mharmsen@redhat.com>
 #
diff --git a/base/server/python/pki/server/upgrade.py b/base/server/python/pki/server/upgrade.py
index ffe7c891d92c4fd16a5e42bdc4d268c2251a0604..116ef3dda289fe6a497f2bb3ef6e3da35a0cb13f 100644
--- a/base/server/python/pki/server/upgrade.py
+++ b/base/server/python/pki/server/upgrade.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 # Authors:
 #     Endi S. Dewata <edewata@redhat.com>
 #
-- 
2.5.0